Index: doc/html/classARX.html
===================================================================
--- doc/html/classARX.html (revision 162)
+++ doc/html/classARX.html (revision 171)
@@ -24,5 +24,5 @@
 </div>
 <div class="contents">
-<h1>ARX Class Reference</h1><!-- doxytag: class="ARX" --><!-- doxytag: inherits="BM" -->Linear Autoregressive model with Gaussian noise.  
+<h1>ARX Class Reference</h1><!-- doxytag: class="ARX" --><!-- doxytag: inherits="BMEF" -->Linear Autoregressive model with Gaussian noise.  
 <a href="#_details">More...</a>
 <p>
@@ -34,5 +34,5 @@
 <p><center><img src="classARX__inherit__graph.png" border="0" usemap="#ARX__inherit__map" alt="Inheritance graph"></center>
 <map name="ARX__inherit__map">
-<area shape="rect" href="classBM.html" title="Bayesian Model of the world, i.e. all uncertainty is modeled by probabilities." alt="" coords="9,7,49,31"></map>
+<area shape="rect" href="classBMEF.html" title="Estimator for Exponential family." alt="" coords="5,84,61,111"><area shape="rect" href="classBM.html" title="Bayesian Model of the world, i.e. all uncertainty is modeled by probabilities." alt="" coords="13,7,53,33"></map>
 <center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>
 <div class="dynheader">
@@ -41,5 +41,5 @@
 <p><center><img src="classARX__coll__graph.png" border="0" usemap="#ARX__coll__map" alt="Collaboration graph"></center>
 <map name="ARX__coll__map">
-<area shape="rect" href="classBM.html" title="Bayesian Model of the world, i.e. all uncertainty is modeled by probabilities." alt="" coords="5,146,45,170"><area shape="rect" href="classRV.html" title="Class representing variables, most often random variables." alt="" coords="32,7,69,31"><area shape="rect" href="classepdf.html" title="Probability density function with numerical statistics, e.g. posterior density." alt="" coords="63,95,108,119"><area shape="rect" href="classldmat.html" title="Matrix stored in LD form, (typically known as UD)." alt="" coords="132,196,185,220"><area shape="rect" href="classegiw.html" title="Gauss&#45;inverse&#45;Wishart density stored in LD form." alt="" coords="63,284,111,308"><area shape="rect" href="classsqmat.html" title="Virtual class for representation of double symmetric matrices in square&#45;root form..." alt="" coords="132,95,188,119"><area shape="rect" href="classeEF.html" title="General conjugate exponential family posterior density." alt="" coords="63,196,108,220"></map>
+<area shape="rect" href="classBMEF.html" title="Estimator for Exponential family." alt="" coords="5,263,61,289"><area shape="rect" href="classBM.html" title="Bayesian Model of the world, i.e. all uncertainty is modeled by probabilities." alt="" coords="12,156,52,183"><area shape="rect" href="classRV.html" title="Class representing variables, most often random variables." alt="" coords="39,7,76,33"><area shape="rect" href="classepdf.html" title="Probability density function with numerical statistics, e.g. posterior density." alt="" coords="69,103,117,129"><area shape="rect" href="classldmat.html" title="Matrix stored in LD form, (typically known as UD)." alt="" coords="139,209,197,236"><area shape="rect" href="classegiw.html" title="Gauss&#45;inverse&#45;Wishart density stored in LD form." alt="" coords="71,316,119,343"><area shape="rect" href="classsqmat.html" title="Virtual class for representation of double symmetric matrices in square&#45;root form..." alt="" coords="141,103,203,129"><area shape="rect" href="classeEF.html" title="General conjugate exponential family posterior density." alt="" coords="72,209,115,236"></map>
 <center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>
 
@@ -48,33 +48,50 @@
 <tr><td></td></tr>
 <tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="5fc6c18e73dcc0f1135eef33f42db8be"></a><!-- doxytag: member="ARX::ARX" ref="5fc6c18e73dcc0f1135eef33f42db8be" args="(RV &amp;rv, mat &amp;V0, double &amp;nu0, double frg0=1.0)" -->
-&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#5fc6c18e73dcc0f1135eef33f42db8be">ARX</a> (<a class="el" href="classRV.html">RV</a> &amp;<a class="el" href="classBM.html#af00f0612fabe66241dd507188cdbf88">rv</a>, mat &amp;V0, double &amp;nu0, double frg0=1.0)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="545e269bf7852c81484cf361b54d9917"></a><!-- doxytag: member="ARX::ARX" ref="545e269bf7852c81484cf361b54d9917" args="(const RV &amp;rv, const mat &amp;V0, const double &amp;nu0, const double frg0=1.0)" -->
+&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#545e269bf7852c81484cf361b54d9917">ARX</a> (const <a class="el" href="classRV.html">RV</a> &amp;<a class="el" href="classBM.html#af00f0612fabe66241dd507188cdbf88">rv</a>, const mat &amp;V0, const double &amp;nu0, const double frg0=1.0)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Full constructor. <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="3ccef8dc9dbed00ec74dddc949845d39"></a><!-- doxytag: member="ARX::set_parameters" ref="3ccef8dc9dbed00ec74dddc949845d39" args="(mat &amp;V0, double &amp;nu0)" -->
-void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#3ccef8dc9dbed00ec74dddc949845d39">set_parameters</a> (mat &amp;V0, double &amp;nu0)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="a5358883a49b52f50755ad8770c2bbdb"></a><!-- doxytag: member="ARX::ARX" ref="a5358883a49b52f50755ad8770c2bbdb" args="(const ARX &amp;A0)" -->
+&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#a5358883a49b52f50755ad8770c2bbdb">ARX</a> (const <a class="el" href="classARX.html">ARX</a> &amp;A0)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Copy constructor. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="d2751057811c6fb8f4ff86e1648bcddc"></a><!-- doxytag: member="ARX::_copy_" ref="d2751057811c6fb8f4ff86e1648bcddc" args="(bool changerv=false)" -->
+<a class="el" href="classBM.html">BM</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#d2751057811c6fb8f4ff86e1648bcddc">_copy_</a> (bool changerv=false)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Auxiliary function. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="bc8c36399e82b2fc504baed845ed2007"></a><!-- doxytag: member="ARX::set_parameters" ref="bc8c36399e82b2fc504baed845ed2007" args="(const ldmat &amp;V0, const double &amp;nu0)" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#bc8c36399e82b2fc504baed845ed2007">set_parameters</a> (const <a class="el" href="classldmat.html">ldmat</a> &amp;V0, const double &amp;nu0)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set sufficient statistics. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="26925d66dfc366815c497d67b62ee49c"></a><!-- doxytag: member="ARX::set_statistics" ref="26925d66dfc366815c497d67b62ee49c" args="(const BMEF *BM0)" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#26925d66dfc366815c497d67b62ee49c">set_statistics</a> (const <a class="el" href="classBMEF.html">BMEF</a> *BM0)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">get statistics from another model <br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="29f55b43b8b6f5c4a55f6176aa85c494"></a><!-- doxytag: member="ARX::get_parameters" ref="29f55b43b8b6f5c4a55f6176aa85c494" args="(mat &amp;V0, double &amp;nu0)" -->
 void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#29f55b43b8b6f5c4a55f6176aa85c494">get_parameters</a> (mat &amp;V0, double &amp;nu0)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns sufficient statistics. <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="ba82c956ca893826811aefe1e4af465d"></a><!-- doxytag: member="ARX::bayes" ref="ba82c956ca893826811aefe1e4af465d" args="(const vec &amp;dt)" -->
-void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#ba82c956ca893826811aefe1e4af465d">bayes</a> (const vec &amp;dt)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="14d62abfe355275ea3b8d0c5d40f01a0"></a><!-- doxytag: member="ARX::bayes" ref="14d62abfe355275ea3b8d0c5d40f01a0" args="(const vec &amp;dt, const double w)" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#14d62abfe355275ea3b8d0c5d40f01a0">bayes</a> (const vec &amp;dt, const double w)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Here <img class="formulaInl" alt="$dt = [y_t psi_t] $" src="form_58.png">. <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="9d8eff7a9df81786191a4c55b27e5b8a"></a><!-- doxytag: member="ARX::_epdf" ref="9d8eff7a9df81786191a4c55b27e5b8a" args="()" -->
-<a class="el" href="classepdf.html">epdf</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#9d8eff7a9df81786191a4c55b27e5b8a">_epdf</a> ()</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#ba82c956ca893826811aefe1e4af465d">bayes</a> (const vec &amp;dt)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Incremental Bayes rule.  <a href="#ba82c956ca893826811aefe1e4af465d"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="c13df43e0af87697fda6b457d56a6d45"></a><!-- doxytag: member="ARX::_epdf" ref="c13df43e0af87697fda6b457d56a6d45" args="() const " -->
+const <a class="el" href="classepdf.html">epdf</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#c13df43e0af87697fda6b457d56a6d45">_epdf</a> () const </td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a pointer to the <a class="el" href="classepdf.html" title="Probability density function with numerical statistics, e.g. posterior density.">epdf</a> representing posterior density on parameters. Use with care! <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#e7f9e7823aec9bf7ddc3b42d9b3304c4">logpred</a> (const vec &amp;dt) const </td></tr>
+
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="365092d4fd1ab769fcf62bf28f364fab"></a><!-- doxytag: member="ARX::flatten" ref="365092d4fd1ab769fcf62bf28f364fab" args="(BMEF *B)" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#365092d4fd1ab769fcf62bf28f364fab">flatten</a> (<a class="el" href="classBMEF.html">BMEF</a> *B)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Flatten the posterior. <br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top">ivec&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#130bb7336aac681ce14b027b8f1409fa">structure_est</a> (<a class="el" href="classegiw.html">egiw</a> Eg0)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Brute force structure estimation.  <a href="#130bb7336aac681ce14b027b8f1409fa"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="b8827048ceec8999849e2ed15400cae7"></a><!-- doxytag: member="ARX::_tll" ref="b8827048ceec8999849e2ed15400cae7" args="()" -->
-double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#b8827048ceec8999849e2ed15400cae7">_tll</a> ()</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">access function <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="87b07867fd4c133aa89a18543f68d9f9"></a><!-- doxytag: member="ARX::bayes" ref="87b07867fd4c133aa89a18543f68d9f9" args="(mat Dt)" -->
-void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classBM.html#87b07867fd4c133aa89a18543f68d9f9">bayes</a> (mat Dt)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="0186270f75189677f390fe088a9947e9"></a><!-- doxytag: member="ARX::bayesB" ref="0186270f75189677f390fe088a9947e9" args="(const mat &amp;Dt)" -->
+virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classBM.html#0186270f75189677f390fe088a9947e9">bayesB</a> (const mat &amp;Dt)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Batch Bayes rule (columns of Dt are observations). <br></td></tr>
@@ -85,4 +102,8 @@
 <tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="87f4a547d2c29180be88175e5eab9c88"></a><!-- doxytag: member="ARX::_ll" ref="87f4a547d2c29180be88175e5eab9c88" args="() const " -->
 double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classBM.html#87f4a547d2c29180be88175e5eab9c88">_ll</a> () const </td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">access function <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="1ffa9f23669aabecc3760c06c6987522"></a><!-- doxytag: member="ARX::set_evalll" ref="1ffa9f23669aabecc3760c06c6987522" args="(bool evl0)" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classBM.html#1ffa9f23669aabecc3760c06c6987522">set_evalll</a> (bool evl0)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">access function <br></td></tr>
@@ -100,16 +121,12 @@
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">cached value of est.nu <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="e467144efb0a5acbc10dba4eff8638fe"></a><!-- doxytag: member="ARX::frg" ref="e467144efb0a5acbc10dba4eff8638fe" args="" -->
-double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#e467144efb0a5acbc10dba4eff8638fe">frg</a></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="538d632e59f9afa8daa1de74da12ce71"></a><!-- doxytag: member="ARX::frg" ref="538d632e59f9afa8daa1de74da12ce71" args="" -->
+double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classBMEF.html#538d632e59f9afa8daa1de74da12ce71">frg</a></td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">forgetting factor <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="6d0cd0f0734aa77cdc5e48f1cf6737ec"></a><!-- doxytag: member="ARX::last_lognc" ref="6d0cd0f0734aa77cdc5e48f1cf6737ec" args="" -->
-double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#6d0cd0f0734aa77cdc5e48f1cf6737ec">last_lognc</a></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="308cf5d4133cd471fdf1ecd5dfa09d02"></a><!-- doxytag: member="ARX::last_lognc" ref="308cf5d4133cd471fdf1ecd5dfa09d02" args="" -->
+double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classBMEF.html#308cf5d4133cd471fdf1ecd5dfa09d02">last_lognc</a></td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">cached value of lognc() in the previous step (used in evaluation of <code>ll</code> ) <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="64ea7c8ff48bf2548bac3e985e24da19"></a><!-- doxytag: member="ARX::tll" ref="64ea7c8ff48bf2548bac3e985e24da19" args="" -->
-double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classARX.html#64ea7c8ff48bf2548bac3e985e24da19">tll</a></td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">total likelihood <br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="af00f0612fabe66241dd507188cdbf88"></a><!-- doxytag: member="ARX::rv" ref="af00f0612fabe66241dd507188cdbf88" args="" -->
 <a class="el" href="classRV.html">RV</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classBM.html#af00f0612fabe66241dd507188cdbf88">rv</a></td></tr>
@@ -123,5 +140,5 @@
 bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classBM.html#bf6fb59b30141074f8ee1e2f43d03129">evalll</a></td></tr>
 
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">If true, the filter will compute likelihood of the data record and store it in <code>ll</code> . Set to false if you want to save time. <br></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">If true, the filter will compute likelihood of the data record and store it in <code>ll</code> . Set to false if you want to save computational time. <br></td></tr>
 </table>
 <hr><a name="_details"></a><h2>Detailed Description</h2>
@@ -136,4 +153,59 @@
 <p>
 Extension for time-variant parameters <img class="formulaInl" alt="$\theta_t,r_t$" src="form_55.png"> may be achived using exponential forgetting (Kulhavy and Zarrop, 1993). In such a case, the forgetting factor <code>frg</code> <img class="formulaInl" alt="$\in <0,1>$" src="form_56.png"> should be given in the constructor. Time-invariant parameters are estimated for <code>frg</code> = 1. <hr><h2>Member Function Documentation</h2>
+<a class="anchor" name="ba82c956ca893826811aefe1e4af465d"></a><!-- doxytag: member="ARX::bayes" ref="ba82c956ca893826811aefe1e4af465d" args="(const vec &amp;dt)" -->
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void ARX::bayes           </td>
+          <td>(</td>
+          <td class="paramtype">const vec &amp;&nbsp;</td>
+          <td class="paramname"> <em>dt</em>          </td>
+          <td>&nbsp;)&nbsp;</td>
+          <td><code> [inline, virtual]</code></td>
+        </tr>
+      </table>
+</div>
+<div class="memdoc">
+
+<p>
+Incremental Bayes rule. 
+<p>
+<dl compact><dt><b>Parameters:</b></dt><dd>
+  <table border="0" cellspacing="2" cellpadding="0">
+    <tr><td valign="top"></td><td valign="top"><em>dt</em>&nbsp;</td><td>vector of input data </td></tr>
+  </table>
+</dl>
+
+<p>Reimplemented from <a class="el" href="classBMEF.html#52b7719312d545215cca1ff87722a35a">BMEF</a>.</p>
+
+<p>References <a class="el" href="bdm_2estim_2arx_8cpp-source.html#l00005">bayes()</a>.</p>
+
+</div>
+</div><p>
+<a class="anchor" name="e7f9e7823aec9bf7ddc3b42d9b3304c4"></a><!-- doxytag: member="ARX::logpred" ref="e7f9e7823aec9bf7ddc3b42d9b3304c4" args="(const vec &amp;dt) const " -->
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">double ARX::logpred           </td>
+          <td>(</td>
+          <td class="paramtype">const vec &amp;&nbsp;</td>
+          <td class="paramname"> <em>dt</em>          </td>
+          <td>&nbsp;)&nbsp;</td>
+          <td> const<code> [virtual]</code></td>
+        </tr>
+      </table>
+</div>
+<div class="memdoc">
+
+<p>
+Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out. 
+<p>Reimplemented from <a class="el" href="classBM.html#8a8ce6df431689964c41cc6c849cfd06">BM</a>.</p>
+
+<p>References <a class="el" href="libEF_8h-source.html#l00185">egiw::_nu()</a>, <a class="el" href="libEF_8h-source.html#l00183">egiw::_V()</a>, <a class="el" href="arx_8h-source.html#l00039">est</a>, <a class="el" href="libBM_8h-source.html#l00280">BM::evalll</a>, <a class="el" href="libEF_8h-source.html#l00078">BMEF::frg</a>, <a class="el" href="libEF_8h-source.html#l00080">BMEF::last_lognc</a>, <a class="el" href="libEF_8cpp-source.html#l00044">egiw::lognc()</a>, <a class="el" href="arx_8h-source.html#l00043">nu</a>, <a class="el" href="libDC_8cpp-source.html#l00058">ldmat::opupdt()</a>, <a class="el" href="libEF_8cpp-source.html#l00099">egiw::pow()</a>, and <a class="el" href="arx_8h-source.html#l00041">V</a>.</p>
+
+</div>
+</div><p>
 <a class="anchor" name="130bb7336aac681ce14b027b8f1409fa"></a><!-- doxytag: member="ARX::structure_est" ref="130bb7336aac681ce14b027b8f1409fa" args="(egiw Eg0)" -->
 <div class="memitem">
@@ -157,5 +229,5 @@
 <dl class="return" compact><dt><b>Returns:</b></dt><dd>indeces of accepted regressors. </dd></dl>
 
-<p>References <a class="el" href="libBM_8h-source.html#l00069">RV::count()</a>, <a class="el" href="arx_8h-source.html#l00039">est</a>, <a class="el" href="libEF_8cpp-source.html#l00031">egiw::lognc()</a>, and <a class="el" href="libBM_8h-source.html#l00264">BM::rv</a>.</p>
+<p>References <a class="el" href="libBM_8h-source.html#l00069">RV::count()</a>, <a class="el" href="arx_8h-source.html#l00039">est</a>, <a class="el" href="libEF_8cpp-source.html#l00044">egiw::lognc()</a>, and <a class="el" href="libBM_8h-source.html#l00276">BM::rv</a>.</p>
 
 </div>
@@ -164,5 +236,5 @@
 <li>work/git/mixpp/bdm/estim/<a class="el" href="arx_8h-source.html">arx.h</a><li>work/git/mixpp/bdm/estim/arx.cpp</ul>
 </div>
-<hr size="1"><address style="text-align: right;"><small>Generated on Thu Sep 4 19:28:05 2008 for mixpp by&nbsp;
+<hr size="1"><address style="text-align: right;"><small>Generated on Tue Sep 23 16:00:48 2008 for mixpp by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.6 </small></address>