Index: doc/html/functions_0x73.html
===================================================================
--- doc/html/functions_0x73.html (revision 171)
+++ doc/html/functions_0x73.html (revision 180)
@@ -65,19 +65,19 @@
 <h3><a class="anchor" name="index_s">- s -</a></h3><ul>
 <li>sample()
-: <a class="el" href="classemix.html#0650601f24e633e0ab09aa1e46c14483">emix</a>
+: <a class="el" href="classmerger.html#379198c3d2063bfa63f5d1245a2511ba">merger</a>
+, <a class="el" href="classemix.html#0650601f24e633e0ab09aa1e46c14483">emix</a>
+, <a class="el" href="classepdf.html#8019654e494bf5e458f6fb947e11b262">epdf</a>
+, <a class="el" href="classeDirich.html#23dff79110822e9639343fe8e177fd80">eDirich</a>
+, <a class="el" href="classegamma.html#8e10c0021b5dfdd9cb62c6959b5ef425">egamma</a>
+, <a class="el" href="classenorm.html#60b47544f6181ffd4530d3e415ce12c5">enorm&lt; sq_T &gt;</a>
+, <a class="el" href="classeuni.html#4a0e09392be17beaee120ba98fc038cd">euni</a>
+, <a class="el" href="classeEmp.html#83f9283f92b805508d896479dc1ccf12">eEmp</a>
 , <a class="el" href="classeprod.html#94a5b7c44056cf7f4e688d53ba6295b4">eprod</a>
-, <a class="el" href="classenorm.html#60b47544f6181ffd4530d3e415ce12c5">enorm&lt; sq_T &gt;</a>
-, <a class="el" href="classegamma.html#8e10c0021b5dfdd9cb62c6959b5ef425">egamma</a>
-, <a class="el" href="classeuni.html#4a0e09392be17beaee120ba98fc038cd">euni</a>
 , <a class="el" href="classenorm.html#60f0f3bfa53d6e65843eea9532b16d36">enorm&lt; sq_T &gt;</a>
-, <a class="el" href="classeEmp.html#83f9283f92b805508d896479dc1ccf12">eEmp</a>
-, <a class="el" href="classepdf.html#8019654e494bf5e458f6fb947e11b262">epdf</a>
 , <a class="el" href="classegiw.html#3d2c1f2ba0f9966781f1e0ae695e8a6f">egiw</a>
-, <a class="el" href="classeDirich.html#23dff79110822e9639343fe8e177fd80">eDirich</a>
 <li>samplecond()
-: <a class="el" href="classmlnorm.html#215fb88cc8b95d64cdefd6849abdd1e8">mlnorm&lt; sq_T &gt;</a>
+: <a class="el" href="classmlnorm.html#decf3e3b5c8e0812e5b4dbe94fa2ae18">mlnorm&lt; sq_T &gt;</a>
 , <a class="el" href="classmprod.html#a48887eb8738a9e5550bfc38eb8e9d68">mprod</a>
 , <a class="el" href="classmpdf.html#3f172b79ec4a5ebc87898a5381141f1b">mpdf</a>
-, <a class="el" href="classmlnorm.html#decf3e3b5c8e0812e5b4dbe94fa2ae18">mlnorm&lt; sq_T &gt;</a>
 <li>sampleN()
 : <a class="el" href="classepdf.html#54d7dd53a641b618771cd9bee135181f">epdf</a>
@@ -98,15 +98,21 @@
 <li>set_evalll()
 : <a class="el" href="classBM.html#1ffa9f23669aabecc3760c06c6987522">BM</a>
+<li>set_id()
+: <a class="el" href="classRV.html#f58db96c9f5b8a538e26f154b1047c62">RV</a>
 <li>set_mu()
 : <a class="el" href="classenorm.html#d892a38f03be12e572ea57d9689cef6b">enorm&lt; sq_T &gt;</a>
 <li>set_parameters()
-: <a class="el" href="classeEmp.html#6606a656c1b28114f7384c25aaf80e8d">eEmp</a>
+: <a class="el" href="classKalman.html#239b28a0380946f5749b2f8d2807f93a">Kalman&lt; sq_T &gt;</a>
+, <a class="el" href="classeEmp.html#eab03bd3381aaea11ce34d5a26556353">eEmp</a>
+, <a class="el" href="classKalmanCh.html#92fb227287af05c9f0078d523c7c9793">KalmanCh</a>
 , <a class="el" href="classEKFfull.html#fc753106e0d4cf68e4f2160fd54458c0">EKFfull</a>
 , <a class="el" href="classEKF.html#28d058ae4d24d992d2f055419a06ee66">EKF&lt; sq_T &gt;</a>
+, <a class="el" href="classeuni.html#4fd7c6a05100616ad16ece405cad7bf2">euni</a>
 , <a class="el" href="classEKFCh.html#0216bed270df59fe65d0d62d41f8257c">EKFCh</a>
-, <a class="el" href="classeuni.html#4fd7c6a05100616ad16ece405cad7bf2">euni</a>
+, <a class="el" href="classmerger.html#79420e251308df4502c834171d518ad9">merger</a>
 , <a class="el" href="classemix.html#6ce82b24d7fe540ddbf44b472a005555">emix</a>
 , <a class="el" href="classmmix.html#e7681490a5c5b2d0a43f4e5842e10a9d">mmix</a>
 , <a class="el" href="classenorm.html#1394a65caa6e00d42e00cc99b12227af">enorm&lt; sq_T &gt;</a>
+, <a class="el" href="classeDirich.html#c842acb2e1cce5cc9000769ff06c086d">eDirich</a>
 , <a class="el" href="classegamma.html#8e348b89be82b70471fe8c5630f61339">egamma</a>
 , <a class="el" href="classmlnorm.html#b6749030c5d5abcb3eb6898f74cea3c0">mlnorm&lt; sq_T &gt;</a>
@@ -116,15 +122,20 @@
 , <a class="el" href="classIMpmsm.html#42818f3426d99fecb7e97be8ffe2e228">IMpmsm</a>
 , <a class="el" href="classARX.html#bc8c36399e82b2fc504baed845ed2007">ARX</a>
-, <a class="el" href="classKalman.html#239b28a0380946f5749b2f8d2807f93a">Kalman&lt; sq_T &gt;</a>
-, <a class="el" href="classKalmanCh.html#92fb227287af05c9f0078d523c7c9793">KalmanCh</a>
+<li>set_samples()
+: <a class="el" href="classeEmp.html#e31bc9e6196173c3480b06a761a3e716">eEmp</a>
+<li>set_size()
+: <a class="el" href="classRV.html#70b24c39c5130b1e4753fa2eef495433">RV</a>
 <li>set_statistics()
 : <a class="el" href="classARX.html#26925d66dfc366815c497d67b62ee49c">ARX</a>
 , <a class="el" href="classBMEF.html#30bb40eb1fd31869b2e62e79e1ecdcb4">BMEF</a>
+<li>set_time()
+: <a class="el" href="classRV.html#af668289c016d12ac2a9ddb85416006b">RV</a>
 <li>setD()
-: <a class="el" href="classldmat.html#7619922b4de18830ce5351c6b5667e60">ldmat</a>
+: <a class="el" href="classldmat.html#0884a613b94fde61bfc84288e73ce57f">ldmat</a>
 , <a class="el" href="classfsqmat.html#922f8190c13987cbcdb33ec2bf5cf105">fsqmat</a>
 , <a class="el" href="classchmat.html#a4fc7f9b0539b97c414442a22f3db6e8">chmat</a>
-, <a class="el" href="classldmat.html#0884a613b94fde61bfc84288e73ce57f">ldmat</a>
 , <a class="el" href="classfsqmat.html#03a8f49eb4d38a054ecc522be59cd2ad">fsqmat</a>
+, <a class="el" href="classchmat.html#4b9271097d8317d9514c5d0d62cccb39">chmat</a>
+, <a class="el" href="classldmat.html#7619922b4de18830ce5351c6b5667e60">ldmat</a>
 <li>setL()
 : <a class="el" href="classldmat.html#32ff66296627ff5341d7c0b973249614">ldmat</a>
@@ -139,22 +150,22 @@
 <li>sqrt_mult()
 : <a class="el" href="classchmat.html#b22aa239dbaca33e3fb93b4f674d7051">chmat</a>
-, <a class="el" href="classfsqmat.html#842a774077ee34ac3c36d180ab33e103">fsqmat</a>
 , <a class="el" href="classsqmat.html#6b79438b5d7544a9c8e110a145355d8f">sqmat</a>
 , <a class="el" href="classldmat.html#fc380626ced6f9244fb58c5f0231174d">ldmat</a>
+, <a class="el" href="classfsqmat.html#842a774077ee34ac3c36d180ab33e103">fsqmat</a>
 <li>step()
-: <a class="el" href="classdirfilelog.html#f5fe9483a041591bfe6f3d6393b02aa7">dirfilelog</a>
+: <a class="el" href="classMemDS.html#21916feb3e5ff960855c09b06a0d279b">MemDS</a>
+, <a class="el" href="classlogger.html#709b3ebefa0da3ed371aa802b06512a2">logger</a>
 , <a class="el" href="classmemlog.html#c97961eda9cda9f0e63c703cf21e5804">memlog</a>
-, <a class="el" href="classMemDS.html#21916feb3e5ff960855c09b06a0d279b">MemDS</a>
-, <a class="el" href="classlogger.html#709b3ebefa0da3ed371aa802b06512a2">logger</a>
 , <a class="el" href="classDS.html#470ba89e8e7c3c4d830803221b4e9be6">DS</a>
+, <a class="el" href="classdirfilelog.html#f5fe9483a041591bfe6f3d6393b02aa7">dirfilelog</a>
 <li>structure_est()
 : <a class="el" href="classARX.html#130bb7336aac681ce14b027b8f1409fa">ARX</a>
 <li>subselect()
-: <a class="el" href="classRV.html#0a9ea7bc6fad270cc54a455a9f8f387d">RV</a>
+: <a class="el" href="classRV.html#b26d25a122be3303806af7726a625a0f">RV</a>
 <li>subt()
-: <a class="el" href="classRV.html#a85c47bd838ebbdcb6798d7843e87db2">RV</a>
+: <a class="el" href="classRV.html#b9d175c327c21488b1e2fb756a84e149">RV</a>
 </ul>
 </div>
-<hr size="1"><address style="text-align: right;"><small>Generated on Tue Sep 23 16:00:47 2008 for mixpp by&nbsp;
+<hr size="1"><address style="text-align: right;"><small>Generated on Thu Oct 9 21:26:34 2008 for mixpp by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.6 </small></address>